package cn.timer.api.config.enums;

import lombok.Getter;

/**
 * @author Tang
 * @version V1.0
 * @Description: 枚举通用类
 * @date 2019 11-12
 */
@Getter
public enum CommonEnum {

	
	NULL_STR(0,""),
	/**
	 * 1 超管理员
	 */
	U_TYPE_ADMIN(0, "超管理员"),

	/**
	 * 2 子管理
	 */
	U_TYPE_C_ADMIN(1, "子管理"),

	/**
	 * 3 普通员工
	 */
	U_TYPE_EMP(2, "普通员工"),

	/**
	 * 0 关闭
	 */
	U_STS_OFF(0, "关闭"),

	/**
	 * 1 开启
	 */
	U_STS_ON(1, "开启"),
	
	/**
	 * 顶级部门上级
	 */
	DEPT_UP_ID(0, "顶级部门上级"),

	/**
	 * 顶级部门上级
	 */
	DEPT_TYPE_ON(0, "打开"),
	
	/**
	 * 企业认证状态
	 */
	AUTH_TYPE_NOHADREVIEW(0,"未认证"),
	AUTH_TYPE_UNDEREVIEW(1,"认证中"),
	AUTH_TYPE_SUCCESS(2,"认证成功"),
	AUTH_TYPE_FAILURE(3,"认证失败"),
	
	/**
	 * 企业系统版本试用
	 */
	LEVEL_PROBATION(0,"试用"),
	/**
	 * 企业系统版本标准
	 */
	LEVEL_STANDARD(1,"标准"),
	/**
	 * 企业系统版本专业
	 */
	LEVEL_PROFESSION(2,"专业"),
	
	/**
	 * 顶级部门上级
	 */
	DEPT_TYPE_OFF(1,"关闭"),
	
	/**
	 * 审批组-其他
	 */
	SPZ_OTHER(999999,"其他")
	;

	private Integer type;

	private String desc;

	CommonEnum(Integer type, String desc) {
		this.type = type;
		this.desc = desc;
	}

	public Integer getType() {
		return this.type;
	}
}